/*
ID: espr1t
TASK: SuperMario
KEYWORDS: Easy, DP
*/

#include <cstdio>
#include <algorithm>

using namespace std;
FILE* in = stdin; FILE* out = stdout;

const int MAX = 10000004;
const long long INF = 1000000000000000001LL;

int n, k;
long long a[MAX];
long long dyn[MAX];

int main(void) {
//    in = fopen("SuperMario.in", "rt");
    
    int F, A, B, M;
    fscanf(in, "%d %d", &n, &k);
    fscanf(in, "%d %d %d %d", &F, &A, &B, &M);
    a[1] = F;
    for (int i = 2; i <= n; i++)
        a[i] = (a[i - 1] * A + B) % M;

    for (int i = n; i >= 0; i--) {
        dyn[i] = i + k > n ? a[i] : INF;
        for (int c = 1; c <= k && i + c <= n; c++)
            dyn[i] = min(dyn[i], a[i] + dyn[i + c]);
    }
    fprintf(out, "%lld\n", dyn[0]);
    return 0;
}
